#include <pthread.h>
#include <semaphore.h>
#include <stdio.h>
#include <stdlib.h>

#define MAX 10000000

// On lance deux threads qui comptent jusqu'à MAX. Naïvement, le résultat
// attendu est 2*MAX. Or, les deux threads sont en situation de compétition ;
// l'accès à MAX n'est pas protégé, et le résultat final est nettement
// inférieur à 2*MAX.

int counter = 0;

void* count(void* data)
{
	int k;

	for (k = 0; k < MAX; k++)
	{
		counter++;
	}
	return NULL;
}

int main(int argc, char * argv[])
{
	pthread_t t1;
	pthread_t t2;

	pthread_create(&t1, NULL, count, NULL);  // create first thread
	pthread_create(&t2, NULL, count, NULL);  // create second thread
	pthread_join(t1, NULL);  // wait for first thread
	pthread_join(t2, NULL);  // wait for second thread

	printf("Counter: %d\n", counter);
	return 0;
}
